pollster/polls/urls.py
from django.urls import path

from . import views

app_name = 'polls'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:question_id>/', views.detail, name='detail'),
    path('<int:question_id>/results/', views.results, name='results'),
    path('<int:question_id>/vote/', views.vote, name='vote'),
]

pollster/pollster/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('polls.urls')),
    path('admin/', admin.site.urls),
]

pollster/polls/models.py
from django.db import models


class Question(models.Model):
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published')

    def __str__(self):
        return self.question_text


class Choice(models.Model):
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)
    question = models.ForeignKey(Question, on_delete=models.CASCADE)

    def __str__(self):
        return self.choice_text

pollster/polls/views.py
from django.http import Http404, HttpResponseRedirect
from django.shortcuts import render, get_object_or_404
from django.urls import reverse

from .models import Question, Choice


# Get questions and display them
def index(request):
    latest_question_list = Question.objects.order_by('-pub_date')[:5]
    context = {
        'latest_question_list': latest_question_list
    }
    return render(request, 'index.html', context)


# Show specific question and choices
def detail(request, question_id):
    try:
        question = Question.objects.get(pk=question_id)
    except Question.DoesNotExist:
        raise Http404("Question does not exist")
    return render(request, 'detail.html', {
        'question': question
    })


# Get question and display results
def results(request, question_id):
    question = get_object_or_404(Question, pk=question_id)
    return render(request, 'results.html', {
        'question': question
    })


# Vote for a question choice
def vote(request, question_id):
    question = get_object_or_404(Question, pk=question_id)
    try:
        selected_choice = question.choice_set.get(pk=request.POST['choice'])
    except (KeyError, Choice.DoesNotExist):
        # Redisplay the question voting form.
        return render(request, 'detail.html', {
            'question': question,
            'error_message': 'You didn\'t select a choice.'
        })
    else:
        selected_choice.votes += 1
        selected_choice.save()
        return HttpResponseRedirect(reverse('polls:results', args=(question.id,)))

pollster/polls/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Pollster {% block title %}{% endblock %}</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
</head>
<body>
{% include 'partials/_navbar.html' %}
<div class="container">
    <div class="row">
        <div class="col-md-6 m-auto">
            {% block content %}{% endblock %}
        </div>
    </div>
</div>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM"
        crossorigin="anonymous"></script>
</body>
</html>

pollster/polls/templates/detail.html
{% extends 'base.html' %}
{% block content %}
    <a href="{% url 'polls:index' %}" class="btn btn-secondary btn-sm mb-3">Back To Polls</a>
    <h1 class="text-center mb-3">{{ question.question_text }}</h1>

    {% if error_message %}
        <p class="alert alert-danger">
            <strong>{{ error_message }}</strong>
        </p>
    {% endif %}

    <form action="{% url 'polls:vote' question.id %}" method="post">
        {% csrf_token %}
        {% for choice in question.choice_set.all %}
            <div class="form-check">
                <input type="radio"
                       name="choice"
                       class="form-check-input"
                       id="choice{{ forloop.counter }}"
                       value="{{ choice.id }}"/>
                <label for="choice{{ forloop.counter }}">{{ choice.choice_text }}</label>
            </div>
        {% endfor %}
        <input type="submit" value="Vote" class="btn btn-success btn-lg btn-block mt-4"/>
    </form>
{% endblock %}

pollster/polls/templates/index.html
{% extends 'base.html' %}

{% block content %}
    <h1 class="text-center mb-3">
        Poll Questions
    </h1>
    {% if latest_question_list %}
        {% for question in latest_question_list %}
            <div class="card mb-3">
                <div class="card-body">
                    <p class="lead">{{ question.question_text }}</p>
                    <a href="{% url 'polls:detail' question.id %}" class="btn btn-primary btm-sm">Vote Now</a>
                    <a href="{% url 'polls:results' question.id %}" class="btn btn-secondary btm-sm">Results</a>
                </div>
            </div>
        {% endfor %}
    {% else %}
        <p>No polls available</p>
    {% endif %}
{% endblock %}

pollster/polls/templates/partials/_navbar.html
<nav class="navbar navbar-dark bg-primary mb-4">
    <div class="container">
        <a href="/" class="navbar-brand">Pollster</a>
    </div>
</nav>

pollster/polls/templates/results.html
{% extends 'base.html' %}
{% block content %}
    <h1 class="mb-5 text-center">{{ question.question_text }}</h1>

    <ul class="list-group mb-5">
        {% for choice in question.choice_set.all %}
            <li class="list-group-item">
                {{ choice.choice_text }}
                <span class="badge bg-success float-end">{{ choice.votes }} vote{{ choice.votes | pluralize }}</span>
            </li>
        {% endfor %}
    </ul>

    <a href="{% url 'polls:index' %}" class="btn btn-secondary">Back To Polls</a>
    <a href="{% url 'polls:detail' question.id %}" class="btn btn-dark">Vote again?</a>
{% endblock %}